# file      : build/cxx/gnu/cxx-o.make
# author    : Boris Kolpackov <boris@kolpackov.net>
# copyright : Copyright (c) 2004 Boris Kolpackov
# license   : GNU GPL v2; http://www.gnu.org/licenses/gpl.txt

$(call include,$(bld_root)/cxx/gnu/configuration.make)

$(out_root)/%.o: cxx := $(cxx_gnu)
$(out_root)/%.o: cxx_options := -Wall $(cxx_gnu_optimization_options) $(cxx_gnu_debugging_options)

#@@ wrong prefix
#
define expand-cpp-lib-options-impl
$(if $1,$(shell sed -e '/^-I/! d' $1))
endef

define expand-cpp-lib-options
$(call expand-cpp-lib-options-impl,$(filter %.l,$1))
endef

$(out_root)/%.o: $(out_root)/%$(cxx_s_suffix) | $$(dir\ $(out_root)/%).
	$(call message,c++ $<,$(cxx) $(cpp_options) $(call expand-cpp-lib-options,$|) \
$(cxx_options) $(cxx_pic_options) -c -MD -MF $@.d -o $@ $<)


ifneq ($(out_root),$(src_root))

$(out_root)/%.o: $(src_root)/%$(cxx_s_suffix) | $$(dir\ $(out_root)/%).
	$(call message,c++ $<,$(cxx) $(cpp_options) $(call expand-cpp-lib-options,$|) \
$(cxx_options) $(cxx_pic_options) -c -MD -MF $@.d -o $@ $<)

endif


.PHONY: $(out_root)/%.o.clean

$(out_root)/%.o.clean:
	$(call message,rm $(basename $@),rm -f $(basename $@) $(basename $@).d)

# These rules are used to handle removed include files.
#
#@@ maybe factor them out as common?
#
#@@ this may not work if path is not absolute.
#
/%.h:: ;
/%$(cxx_h_suffix):: ;
/%$(cxx_t_suffix):: ;
/%$(cxx_i_suffix):: ;
